#! /usr/bin/env ruby
# $Id: gdbmdump 1 2005-05-18 20:45:15Z basile $
## -*- ruby -*-

require 'gdbm'

srcdbmname=ARGV[0]
destxtname=ARGV[1]

STDERR.printf("start dumping gdbm %s into %s\n", srcdbmname, destxtname)

if (not File.exists?(srcdbmname)) then
  STDERR.printf("source dbm %s does not exist\n", srcdbmname);
  exit(1)
end

keyarr=Array::new

#GDBM.open(srcdbmname, 0400) do |gdbm|
GDBM.open(srcdbmname) do |gdbm|
  nbk=0
  gdbm.each do |key,val|
    if /^[a-zA-Z0-9+*._@,!(){}-]*$/ =~ key then
      keyarr << key
      nbk = nbk + 1
    else
      STDERR.printf("bad key %s in file %s\n", key.inspect, srcdbmname);
      exit(1)
    end
  end
  STDERR.printf("got and sorting %d keys\n", nbk)
  keyarr.sort!
  if (File.exists?(destxtname)) then
    File.rename(destxtname,destxtname+"~")
  end
  File.open(destxtname, "w") do |out|
    keyarr.each do |key|
      val=gdbm[key]
      out.printf("%s\t%s\n", key, val.inspect)
    end
  end
end

STDERR.printf("end dumping gdbm %s into %s\n", srcdbmname, destxtname)
